//package org.aohe.control;
//
//import cn.hutool.core.codec.Base64;
//import cn.hutool.core.lang.Console;
//import cn.hutool.log.Log;
//import cn.hutool.log.LogFactory;
//import cn.hutool.log.StaticLog;
//import com.alibaba.fastjson2.JSONObject;
//import org.aohe.core.twain.*;
//import org.aohe.exceptions.TwainException;
//import org.aohe.result.R;
//import org.aohe.scan.Source;
//import org.aohe.scan.SourceManager;
//
//import java.io.File;
//import java.util.*;
//
//public class Operational {
//
//    private static final Log log = LogFactory.get();
//
//    private static TwainScanner scanner = null;
//
//    public static String selectOperational(String path) {
//        JSONObject json = JSONObject.parse(path);
//
//        //操作符
//        String function = json.getString("function");
//
//        //参数符
//        JSONObject param = json.getJSONObject("params");
//
//        R r = R.ok();
//        try {
//            if("001001".equals(function)){
//                //获取扫描仪列表
//                r = getDevices();
//            } else if ("001002".equals(function)) {
//                //选择扫描仪
//                r = setScanner(param.getString("scannerId"));
//            }else if ("001003".equals(function)){
//                //获取扫描仪操作符列表
//                r = getDeviceOperations();
//            }else if ("001004".equals(function)){
//                //r = setDeviceOperations();
//            }else if ("001007".equals(function)){
//                r = setDeviceOperations(param);
//            }else if ("001008".equals(function)){
//                r = startScan(param.getString("scannerId"));
//            }else if ("001012".equals(function)){
//                closeTwSource();
//            }else if ("001013".equals(function)){
//                closeTwSource();
//            }else if ("001015".equals(function)){
//                r = startScan(param.getString("scannerId"),true);
//            }else if ("001016".equals(function)){
//                r = startScan(param.getString("scannerId"),true);
//            }
//        } catch (TwainException e) {
//            StaticLog.error("获取驱动列表失败");
//            StaticLog.error(e);
//            throw new RuntimeException(e);
//        } catch (InterruptedException e) {
//            StaticLog.error("选择驱动失败");
//            StaticLog.error(e);
//            throw new RuntimeException(e);
//        }
//
//        return r.toJsonStr();
//    }
//
//    /**
//     * 001001
//     * 获取连接到当前终端的所有扫描仪并返回设备的SN号
//     *
//     * @return R<list>
//     */
//    public static R getDevices () throws TwainException {
//        return R.ok(TwainSource.getProductNamesToList());
//    }
//
//    /**
//     * 001002
//     * 选中某一获取到的扫描仪
//     * @return R<boolean> -> success
//     */
//    public static R setScanner(String name) throws TwainException, InterruptedException {
//        if(name == null || name.isEmpty()){
//            return R.fail("扫描仪名字为空");
//        }
//
//        TwainScanner.getScanner().select(name);
//        Twain.getSourceManager().selectSource(name);
//
//        return R.ok();
//    }
//
//    public static void main(String[] args) throws TwainException {
//        System.out.println(TwainScanner.getScanner().getDeviceNames());
//    }
//
//    /**
//     * 001003
//     * 获取当前选中扫描仪可配置的项
//     * @return
//     */
//    public static R getDeviceOperations() throws TwainException {
//
//        try{
//            TwainSource twainSource = openTwSource();
//            TwainCapability[] capabilities = twainSource.getCapabilities();
//
//
//            Map<String, List<String>> map = new HashMap<>();
//            for (TwainCapability cap : capabilities){
//                List<String> list = new ArrayList<>();
//
//                String key  = Twain.getMapCapCodeToName().get(cap.cap);
//                String formatKey = String.format("0x%04x", cap.cap);
//
//                list.add(key);
//                list.add(formatKey);
//
//                map.put(key,list);
//            }
//            return  R.ok(map);
//        }finally {
//            closeTwSource();
//        }
//
//
//
//
//
//    }
//
//    /**
//     * 001004
//     * 设置或修改当前选中扫描仪某一配置项的能力值
//     * DPI --> double
//     * 色彩模式 color 0,1,2 -> 黑白，灰度，彩色
//     * 进纸模式 paper true,false -> 自动，手动
//     * @param map 参数和值
//     * @return R
//     */
//    public static R setDeviceOperations(JSONObject map){
//        try {
//            TwainSource twainSource = Twain.getSourceManager().getSource();
//            // 先约定为三种参数 DPI,色彩模式,进纸模式
//            if(map.get("dpi") !=null){
//                twainSource.setResolution(map.getDouble("dpi"));
//            }
//            if(map.get("color") !=null){
//                twainSource.setCapability(Twain.ICAP_PIXELTYPE, map.getInteger("color"));
//            }
//            if(map.get("paper") !=null){
//                twainSource.setCapability(Twain.CAP_FEEDERENABLED, map.getBooleanValue("paper"));
//            }
//        } catch (TwainException e) {
//            throw new RuntimeException(e);
//        }
//        return R.ok();
//    }
//
//    /**
//     * 001008
//     * 当前扫描仪启动扫描
//     * @param name 扫描仪名称
//     * @return R
//     * @throws TwainException default error
//     */
//    public static R startScan(String name) throws TwainException {
//        return startScan(name, false);
//    }
//
//    /**
//     * 001008
//     * 当前扫描仪启动扫描
//     * @param name 扫描仪名称
//     * @param systemUI 是否使用打印机自带UI
//     * @return R
//     * @throws TwainException default error
//     */
//    public static R startScan(String name, boolean systemUI ) throws TwainException {
//        Source source = new Source();
//        source.setName(name);
//        source.setSystemUI(systemUI);
//        List<File> fileList = source.scan();
//        List<String> base64Files = new ArrayList<>();
//        for (File file : fileList){
//            base64Files.add(Base64.encode(file));
//        }
//        return R.ok(base64Files);
//    }
//
////    public static void main(String[] args) throws TwainException, InterruptedException {
////        List<String> list = (List<String>) getDevices().getData();
////        System.out.println(list.get(0));
////        R r = setScanner(list.get(0));
////        //System.out.println(getDeviceOperations());
////        System.out.println(startScan(list.get(0), false));
////        ;
////    }
//
//
//    /**
//     * 打开接口
//     * @return twSource
//     * @throws TwainException 默认错误
//     */
//    public static TwainSource openTwSource() throws TwainException {
//        TwainSource twainSource = Twain.getSourceManager().getSource();
//
//        if(twainSource.getState() != 4){
//            //打开接口
//            Twain.getSourceManager().openSource();
//        }
//        return twainSource;
//    }
//
//    /**
//     * 关闭接口
//     * @throws TwainException 默认错误
//     */
//    public static void closeTwSource() throws TwainException {
//        TwainSource twainSource = Twain.getSourceManager().getSource();
//        twainSource.close();
//    }
//
//    public void getSetting(Integer i) throws TwainException {
//
//        try{
//            TwainSource twainSource = openTwSource();
//            TwainCapability tc = twainSource.getCapability(i);
//            Console.log(tc.getItems());
//        } catch (TwainException e) {
//            throw new RuntimeException(e);
//        } finally {
//            closeTwSource();
//        }
//    }
//}
